Index: /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/izoom_axis_attr.F90
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/izoom_axis_attr.F90	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/izoom_axis_attr.F90	(revision 1205)
@@ -12,5 +12,5 @@
 
   SUBROUTINE xios(set_zoom_axis_attr)  &
-    ( zoom_axis_id, begin, n )
+    ( zoom_axis_id, begin, index, n )
 
     IMPLICIT NONE
@@ -18,4 +18,5 @@
       CHARACTER(LEN=*), INTENT(IN) ::zoom_axis_id
       INTEGER  , OPTIONAL, INTENT(IN) :: begin
+      INTEGER  , OPTIONAL, INTENT(IN) :: index(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: n
 
@@ -23,27 +24,29 @@
       (zoom_axis_id,zoom_axis_hdl)
       CALL xios(set_zoom_axis_attr_hdl_)   &
-      ( zoom_axis_hdl, begin, n )
+      ( zoom_axis_hdl, begin, index, n )
 
   END SUBROUTINE xios(set_zoom_axis_attr)
 
   SUBROUTINE xios(set_zoom_axis_attr_hdl)  &
-    ( zoom_axis_hdl, begin, n )
+    ( zoom_axis_hdl, begin, index, n )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis)) , INTENT(IN) :: zoom_axis_hdl
       INTEGER  , OPTIONAL, INTENT(IN) :: begin
+      INTEGER  , OPTIONAL, INTENT(IN) :: index(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: n
 
       CALL xios(set_zoom_axis_attr_hdl_)  &
-      ( zoom_axis_hdl, begin, n )
+      ( zoom_axis_hdl, begin, index, n )
 
   END SUBROUTINE xios(set_zoom_axis_attr_hdl)
 
   SUBROUTINE xios(set_zoom_axis_attr_hdl_)   &
-    ( zoom_axis_hdl, begin_, n_ )
+    ( zoom_axis_hdl, begin_, index_, n_ )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis)) , INTENT(IN) :: zoom_axis_hdl
       INTEGER  , OPTIONAL, INTENT(IN) :: begin_
+      INTEGER  , OPTIONAL, INTENT(IN) :: index_(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: n_
 
@@ -51,4 +54,9 @@
         CALL cxios_set_zoom_axis_begin &
       (zoom_axis_hdl%daddr, begin_)
+      ENDIF
+
+      IF (PRESENT(index_)) THEN
+        CALL cxios_set_zoom_axis_index &
+      (zoom_axis_hdl%daddr, index_, SHAPE(index_))
       ENDIF
 
@@ -61,5 +69,5 @@
 
   SUBROUTINE xios(get_zoom_axis_attr)  &
-    ( zoom_axis_id, begin, n )
+    ( zoom_axis_id, begin, index, n )
 
     IMPLICIT NONE
@@ -67,4 +75,5 @@
       CHARACTER(LEN=*), INTENT(IN) ::zoom_axis_id
       INTEGER  , OPTIONAL, INTENT(OUT) :: begin
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: n
 
@@ -72,27 +81,29 @@
       (zoom_axis_id,zoom_axis_hdl)
       CALL xios(get_zoom_axis_attr_hdl_)   &
-      ( zoom_axis_hdl, begin, n )
+      ( zoom_axis_hdl, begin, index, n )
 
   END SUBROUTINE xios(get_zoom_axis_attr)
 
   SUBROUTINE xios(get_zoom_axis_attr_hdl)  &
-    ( zoom_axis_hdl, begin, n )
+    ( zoom_axis_hdl, begin, index, n )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis)) , INTENT(IN) :: zoom_axis_hdl
       INTEGER  , OPTIONAL, INTENT(OUT) :: begin
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: n
 
       CALL xios(get_zoom_axis_attr_hdl_)  &
-      ( zoom_axis_hdl, begin, n )
+      ( zoom_axis_hdl, begin, index, n )
 
   END SUBROUTINE xios(get_zoom_axis_attr_hdl)
 
   SUBROUTINE xios(get_zoom_axis_attr_hdl_)   &
-    ( zoom_axis_hdl, begin_, n_ )
+    ( zoom_axis_hdl, begin_, index_, n_ )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis)) , INTENT(IN) :: zoom_axis_hdl
       INTEGER  , OPTIONAL, INTENT(OUT) :: begin_
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index_(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: n_
 
@@ -100,4 +111,9 @@
         CALL cxios_get_zoom_axis_begin &
       (zoom_axis_hdl%daddr, begin_)
+      ENDIF
+
+      IF (PRESENT(index_)) THEN
+        CALL cxios_get_zoom_axis_index &
+      (zoom_axis_hdl%daddr, index_, SHAPE(index_))
       ENDIF
 
@@ -110,5 +126,5 @@
 
   SUBROUTINE xios(is_defined_zoom_axis_attr)  &
-    ( zoom_axis_id, begin, n )
+    ( zoom_axis_id, begin, index, n )
 
     IMPLICIT NONE
@@ -117,4 +133,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: begin
       LOGICAL(KIND=C_BOOL) :: begin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index
+      LOGICAL(KIND=C_BOOL) :: index_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: n
       LOGICAL(KIND=C_BOOL) :: n_tmp
@@ -123,10 +141,10 @@
       (zoom_axis_id,zoom_axis_hdl)
       CALL xios(is_defined_zoom_axis_attr_hdl_)   &
-      ( zoom_axis_hdl, begin, n )
+      ( zoom_axis_hdl, begin, index, n )
 
   END SUBROUTINE xios(is_defined_zoom_axis_attr)
 
   SUBROUTINE xios(is_defined_zoom_axis_attr_hdl)  &
-    ( zoom_axis_hdl, begin, n )
+    ( zoom_axis_hdl, begin, index, n )
 
     IMPLICIT NONE
@@ -134,14 +152,16 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: begin
       LOGICAL(KIND=C_BOOL) :: begin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index
+      LOGICAL(KIND=C_BOOL) :: index_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: n
       LOGICAL(KIND=C_BOOL) :: n_tmp
 
       CALL xios(is_defined_zoom_axis_attr_hdl_)  &
-      ( zoom_axis_hdl, begin, n )
+      ( zoom_axis_hdl, begin, index, n )
 
   END SUBROUTINE xios(is_defined_zoom_axis_attr_hdl)
 
   SUBROUTINE xios(is_defined_zoom_axis_attr_hdl_)   &
-    ( zoom_axis_hdl, begin_, n_ )
+    ( zoom_axis_hdl, begin_, index_, n_ )
 
     IMPLICIT NONE
@@ -149,4 +169,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: begin_
       LOGICAL(KIND=C_BOOL) :: begin__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index_
+      LOGICAL(KIND=C_BOOL) :: index__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: n_
       LOGICAL(KIND=C_BOOL) :: n__tmp
@@ -156,4 +178,10 @@
       (zoom_axis_hdl%daddr)
         begin_ = begin__tmp
+      ENDIF
+
+      IF (PRESENT(index_)) THEN
+        index__tmp = cxios_is_defined_zoom_axis_index &
+      (zoom_axis_hdl%daddr)
+        index_ = index__tmp
       ENDIF
 
Index: /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/zoom_axis_interface_attr.F90
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/zoom_axis_interface_attr.F90	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/zoom_axis_interface_attr.F90	(revision 1205)
@@ -29,4 +29,25 @@
 
 
+    SUBROUTINE cxios_set_zoom_axis_index(zoom_axis_hdl, index, extent) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE       :: zoom_axis_hdl
+      INTEGER (KIND=C_INT)     , DIMENSION(*) :: index
+      INTEGER (kind = C_INT), DIMENSION(*)     :: extent
+    END SUBROUTINE cxios_set_zoom_axis_index
+
+    SUBROUTINE cxios_get_zoom_axis_index(zoom_axis_hdl, index, extent) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE       :: zoom_axis_hdl
+      INTEGER (KIND=C_INT)     , DIMENSION(*) :: index
+      INTEGER (kind = C_INT), DIMENSION(*)     :: extent
+    END SUBROUTINE cxios_get_zoom_axis_index
+
+    FUNCTION cxios_is_defined_zoom_axis_index(zoom_axis_hdl) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_zoom_axis_index
+      INTEGER (kind = C_INTPTR_T), VALUE :: zoom_axis_hdl
+    END FUNCTION cxios_is_defined_zoom_axis_index
+
+
     SUBROUTINE cxios_set_zoom_axis_n(zoom_axis_hdl, n) BIND(C)
       USE ISO_C_BINDING
Index: /XIOS/dev/branch_yushan_merged/src/io/nc4_data_output.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/io/nc4_data_output.cpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/io/nc4_data_output.cpp	(revision 1205)
@@ -11,4 +11,5 @@
 #include "netCdfException.hpp"
 #include "exception.hpp"
+#include "timer.hpp"
 #include "uuid.hpp"
 // mpi.hpp
@@ -79,5 +80,5 @@
 
 
-         StdString dimXid, dimYid ;
+        StdString dimXid, dimYid ;
 
         nc_type typePrec ;
@@ -1045,7 +1046,5 @@
         int zoom_begin_srv = axis->zoom_begin_srv;
         int zoom_size  = (MULTI_FILE == SuperClass::type) ? zoom_size_srv
-                                                              : axis->global_zoom_n;
-        int zoom_begin = (MULTI_FILE == SuperClass::type) ? zoom_begin_srv
-                                                              : axis->global_zoom_begin;
+                                                          : axis->global_zoom_size_srv;
 
         if ((0 == zoom_size_srv) && (MULTI_FILE == SuperClass::type)) return;
@@ -1102,5 +1101,5 @@
 
             SuperClassWriter::definition_end();
-            printf("SuperClass::type = %d, typePrec = %d\n", SuperClass::type, typePrec);
+
             switch (SuperClass::type)
             {
@@ -1126,5 +1125,5 @@
                 std::vector<StdSize> start(1), startBounds(2) ;
                 std::vector<StdSize> count(1), countBounds(2) ;
-                start[0] = startBounds[0] = zoom_begin_srv-axis->global_zoom_begin;
+                start[0] = startBounds[0] = zoom_begin_srv-axis->global_zoom_begin_srv;
                 count[0] = countBounds[0] = zoom_size_srv;
                 startBounds[1] = 0;
@@ -1832,17 +1831,19 @@
 
          singleDomain = (file->nbDomains == 1);
+
+         StdString conv_str ;
+         if (file->convention_str.isEmpty())
+         {
+            if (SuperClassWriter::useCFConvention) conv_str="CF-1.6" ;
+            else conv_str="UGRID" ;
+         }
+         else conv_str=file->convention_str ;
+           
          try
          {
-       if (SuperClassWriter::useCFConvention)
-             this->writeFileAttributes(filename, description,
-                                       StdString("CF-1.6"),
-                                       StdString("An IPSL model"),
-                                       this->getTimeStamp());
-           else
-             this->writeFileAttributes(filename, description,
-                                       StdString("UGRID"),
-                                       StdString("An IPSL model"),
-                                       this->getTimeStamp());
-
+           this->writeFileAttributes(filename, description,
+                                      conv_str,
+                                      StdString("An IPSL model"),
+                                      this->getTimeStamp());
 
            if (!appendMode)
@@ -1989,9 +1990,16 @@
         CGrid* grid = field->grid;
 
-        if (field->getNStep()<1) return ;
+        if (field->getNStep()<1) 
+        {
+          return;
+        }
         
         if (!grid->doGridHaveDataToWrite())
-          if (SuperClass::type == MULTI_FILE || !isCollective) return;
-
+          if (SuperClass::type == MULTI_FILE || !isCollective)
+          {
+            return;
+          }
+
+          
         StdString fieldid = field->getFieldOutputName();
 
@@ -2118,17 +2126,25 @@
               case (MULTI_FILE) :
               {
+                 CTimer::get("Files : writing data").resume();
                  SuperClassWriter::writeData(fieldData, fieldid, isCollective, field->getNStep() - 1);
+                 CTimer::get("Files : writing data").suspend();
                  if (wtime)
                  {
+                   CTimer::get("Files : writing time axis").resume();
                    if ( wtimeData)
                    {
-                     SuperClassWriter::writeData(time_data, timeAxisId, isCollective, field->getNStep() - 1);
-                     SuperClassWriter::writeData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep() - 1);
-                   }
+//                     SuperClassWriter::writeData(time_data, timeAxisId, isCollective, field->getNStep() - 1);
+//                     SuperClassWriter::writeData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep() - 1);
+                       SuperClassWriter::writeTimeAxisData(time_data, timeAxisId, isCollective, field->getNStep() - 1, isRoot);
+                       SuperClassWriter::writeTimeAxisDataBounds(time_data_bound, timeAxisBoundId, isCollective, field->getNStep() - 1, isRoot);
+                  }
                    if (wtimeCounter)
                    {
-                     SuperClassWriter::writeData(time_counter, getTimeCounterName(), isCollective, field->getNStep() - 1);
-                     if (timeCounterType!=record) SuperClassWriter::writeData(time_counter_bound, timeBoundId, isCollective, field->getNStep() - 1);
+//                     SuperClassWriter::writeData(time_counter, getTimeCounterName(), isCollective, field->getNStep() - 1);
+//                     if (timeCounterType!=record) SuperClassWriter::writeData(time_counter_bound, timeBoundId, isCollective, field->getNStep() - 1);
+                     SuperClassWriter::writeTimeAxisData(time_counter, getTimeCounterName(), isCollective, field->getNStep() - 1,isRoot);
+                     if (timeCounterType!=record) SuperClassWriter::writeTimeAxisDataBounds(time_counter_bound, timeBoundId, isCollective, field->getNStep() - 1, isRoot);
                    }
+                   CTimer::get("Files : writing time axis").suspend();
                  }
                  break;
@@ -2256,17 +2272,28 @@
                 }
 
+
+                CTimer::get("Files : writing data").resume();
                 SuperClassWriter::writeData(fieldData, fieldid, isCollective, field->getNStep() - 1, &start, &count);
+                CTimer::get("Files : writing data").suspend();
+
                  if (wtime)
                  {
+                   CTimer::get("Files : writing time axis").resume();
                    if ( wtimeData)
                    {
-                     SuperClassWriter::writeData(time_data, timeAxisId, isCollective, field->getNStep() - 1);
-                     SuperClassWriter::writeData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep() - 1);
+//                     SuperClassWriter::writeData(time_data, timeAxisId, isCollective, field->getNStep() - 1);
+//                     SuperClassWriter::writeData(time_data_bound, timeAxisBoundId, isCollective, field->getNStep() - 1);
+                     SuperClassWriter::writeTimeAxisData(time_data, timeAxisId, isCollective, field->getNStep() - 1, isRoot);
+                     SuperClassWriter::writeTimeAxisDataBounds(time_data_bound, timeAxisBoundId, isCollective, field->getNStep() - 1, isRoot);
                    }
                    if (wtimeCounter)
                    {
-                     SuperClassWriter::writeData(time_counter, getTimeCounterName(), isCollective, field->getNStep() - 1);
-                     if (timeCounterType!=record) SuperClassWriter::writeData(time_counter_bound, timeBoundId, isCollective, field->getNStep() - 1);
+//                     SuperClassWriter::writeData(time_counter, getTimeCounterName(), isCollective, field->getNStep() - 1);
+//                     if (timeCounterType!=record) SuperClassWriter::writeData(time_counter_bound, timeBoundId, isCollective, field->getNStep() - 1);
+                     SuperClassWriter::writeTimeAxisData(time_counter, getTimeCounterName(), isCollective, field->getNStep() - 1,isRoot);
+                     if (timeCounterType!=record) SuperClassWriter::writeTimeAxisDataBounds(time_counter_bound, timeBoundId, isCollective, field->getNStep() - 1, isRoot);
+
                    }
+                   CTimer::get("Files : writing time axis").suspend();  
                  }
 
Index: /XIOS/dev/branch_yushan_merged/src/io/onetcdf4.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/io/onetcdf4.cpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/io/onetcdf4.cpp	(revision 1205)
@@ -6,5 +6,5 @@
 #include "netCdfInterface.hpp"
 #include "netCdfException.hpp"
-// mpi_std.hpp
+#include "timer.hpp"
 
 namespace xios
@@ -54,9 +54,11 @@
          if (!append || !std::ifstream(filename.c_str()))
          {
+            CTimer::get("Files : create").resume();
             if (wmpi)
                CNetCdfInterface::createPar(filename, mode, *comm, MPI_INFO_NULL_STD, this->ncidp);
             else
                CNetCdfInterface::create(filename, mode, this->ncidp);
-
+            CTimer::get("Files : create").suspend();
+ 
             this->appendMode = false;
          }
@@ -64,10 +66,10 @@
          {
             mode |= NC_WRITE;
+            CTimer::get("Files : open").resume();
             if (wmpi)
-               //CNetCdfInterface::openPar(filename, mode, static_cast<MPI_Comm>(comm->mpi_comm), MPI_INFO_NULL_STD, this->ncidp);
                CNetCdfInterface::openPar(filename, mode, *comm, MPI_INFO_NULL_STD, this->ncidp);
             else
                CNetCdfInterface::open(filename, mode, this->ncidp);
-
+            CTimer::get("Files : open").suspend();
             this->appendMode = true;
          }
@@ -83,5 +85,7 @@
       void CONetCDF4::close()
       {
+        CTimer::get("Files : close").resume();
         CNetCdfInterface::close(this->ncidp);
+        CTimer::get("Files : close").suspend();
       }
 
@@ -558,5 +562,7 @@
 
          this->getWriteDataInfos(name, 0, array_size,  sstart, scount, NULL, NULL);
+
          this->writeData_(grpid, varid, sstart, scount, data.dataFirst());
+
       }
 
@@ -584,15 +590,34 @@
 
          this->getWriteDataInfos(name, record, array_size,  sstart, scount, NULL, NULL);
-         if (using_netcdf_internal)
-         {
-           if (!isRoot)
-           {
-             sstart[0] = sstart[0] + 1;
-             scount[0] = 0;
-           }
-         }
          this->writeData_(grpid, varid, sstart, scount, data.dataFirst());
        }
 
+      void CONetCDF4::writeTimeAxisDataBounds(const CArray<double, 1>& data, const StdString& name,
+                                        bool collective, StdSize record, bool isRoot)
+      {
+         int grpid = this->getCurrentGroup();
+         int varid = this->getVariable(name);
+
+         map<int,size_t>::iterator it=timeAxis.find(varid);
+         if (it == timeAxis.end()) timeAxis[varid] = record;
+         else
+         {
+           if (it->second >= record) return;
+           else it->second =record;
+         }
+
+         StdSize array_size = 1;
+         std::vector<StdSize> sstart, scount;
+
+         if (this->wmpi && collective)
+            CNetCdfInterface::varParAccess(grpid, varid, NC_COLLECTIVE);
+         if (this->wmpi && !collective)
+            CNetCdfInterface::varParAccess(grpid, varid, NC_INDEPENDENT);
+
+         this->getWriteDataInfos(name, record, array_size,  sstart, scount, NULL, NULL);
+         this->writeData_(grpid, varid, sstart, scount, data.dataFirst());
+       }
+
+
       //---------------------------------------------------------------
 
Index: /XIOS/dev/branch_yushan_merged/src/io/onetcdf4.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/io/onetcdf4.hpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/io/onetcdf4.hpp	(revision 1205)
@@ -73,4 +73,6 @@
             void writeTimeAxisData(const CArray<double,1>& data, const StdString& name,
                                    bool collective, StdSize record, bool Isroot);
+            void writeTimeAxisDataBounds(const CArray<double,1>& data, const StdString& name,
+                                   bool collective, StdSize record, bool Isroot);
             /// Accesseur ///
             const CONetCDF4Path& getCurrentPath(void) const;
Index: /XIOS/dev/branch_yushan_merged/src/io/onetcdf4_impl.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/io/onetcdf4_impl.hpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/io/onetcdf4_impl.hpp	(revision 1205)
@@ -25,6 +25,9 @@
     CNetCdfInterface::varParAccess(grpid, varid, NC_INDEPENDENT);
 
+    CTimer::get("Files : get data infos").resume();
     this->getWriteDataInfos
     (name, record, array_size,  sstart, scount, start, count);
+    CTimer::get("Files : get data infos").suspend();
+
     if (data.numElements() != array_size)
     {
@@ -54,6 +57,8 @@
     CNetCdfInterface::varParAccess(grpid, varid, NC_INDEPENDENT);
 
-    this->getWriteDataInfos
-    (name, record, array_size,  sstart, scount, start, count);
+    CTimer::get("CONetCDF4::writeData getWriteDataInfos").resume();
+    this->getWriteDataInfos(name, record, array_size,  sstart, scount, start, count);
+    CTimer::get("CONetCDF4::writeData getWriteDataInfos").suspend();
+ 
     if (data.numElements()*stringArrayLen != array_size)
     {
@@ -72,5 +77,7 @@
       PtrArrayStr[it->size()]='\0' ;
     }
+    CTimer::get("CONetCDF4::writeData writeData_").resume();
     this->writeData_(grpid, varid, sstart, scount, ArrayStr);
+    CTimer::get("CONetCDF4::writeData writeData_").suspend();
     delete [] ArrayStr ;
   }
Index: /XIOS/dev/branch_yushan_merged/src/memtrack.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/memtrack.cpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/memtrack.cpp	(revision 1205)
@@ -52,4 +52,7 @@
 {
   void addr2line(const char *file_name, char** addr, int naddr) ;
+#ifdef XIOS_MEMTRACK_LIGHT
+  void addr2line(const char *file_name, char** addr, int naddr) {} 
+#endif
 }
 /* ------------------------------------------------------------ */
@@ -59,4 +62,9 @@
 namespace MemTrack
 {
+    size_t currentMemorySize=0 ;
+    size_t maxMemorySize=0 ; 
+
+    size_t getCurrentMemorySize(void) {return currentMemorySize; }
+    size_t getMaxMemorySize(void) {return maxMemorySize ; }
 
     /* ------------------------------------------------------------ */
@@ -376,4 +384,7 @@
         // Get the offset to the user chunk and return it.
         UserChunk *pUser = GetUserAddress(pProlog);
+
+        currentMemorySize += size ;
+        if (currentMemorySize>maxMemorySize) maxMemorySize=currentMemorySize ;
         
         return pUser;
@@ -401,4 +412,5 @@
         // Unlink the block header from the list and destroy it.
         BlockHeader *pBlockHeader = GetHeaderAddress(pProlog);
+        currentMemorySize-=pBlockHeader->GetRequestedSize();
         BlockHeader::RemoveNode(pBlockHeader);
         pBlockHeader->~BlockHeader();
Index: /XIOS/dev/branch_yushan_merged/src/memtrack.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/memtrack.hpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/memtrack.hpp	(revision 1205)
@@ -61,5 +61,6 @@
     void TrackDumpBlocks();
     void TrackListMemoryUsage();
-
+    size_t getCurrentMemorySize(void) ;
+    size_t getMaxMemorySize(void) ;
     /* ---------------------------------------- operator * (MemStamp, ptr) */
 
Index: /XIOS/dev/branch_yushan_merged/src/node/axis.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/node/axis.cpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/node/axis.cpp	(revision 1205)
@@ -367,4 +367,9 @@
     // We don't check if the mask is valid here, just if a mask has been defined at this point.
     isCompressible_ = !mask.isEmpty();
+  }
+
+  bool CAxis::zoomByIndex()
+  {
+    return (!global_zoom_index.isEmpty() && (0 != global_zoom_index.numElements()));
   }
 
@@ -463,20 +468,35 @@
     size_t nZoomCount = 0;
     size_t nbIndex = index.numElements();
-    for (size_t idx = 0; idx < nbIndex; ++idx)
+
+    int end = (0 == n) ? begin : begin + n - 1;
+    int zoom_size = zoomByIndex() ? global_zoom_index.numElements() : global_zoom_n;
+    int minInd = min(index);
+    int maxInd = max(index);
+    for (size_t idx = 0; idx < zoom_size; ++idx)
+    {
+      size_t globalZoomIndex = zoomByIndex() ? global_zoom_index(idx) : global_zoom_begin + idx;
+      if (globalZoomIndex >= minInd && globalZoomIndex <= maxInd) ++nZoomCount;
+    }
+
+/*    for (size_t idx = 0; idx < nbIndex; ++idx)
     {
       size_t globalIndex = index(idx);
       if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end) ++nZoomCount;
-    }
-
+    }*/
+    
     CArray<size_t,1> globalIndexAxis(nbIndex);
+    for (size_t idx = 0; idx < nbIndex; ++idx)
+    {      
+      globalIndexAxis(idx) = (size_t)index(idx);
+    }
+
     std::vector<size_t> globalAxisZoom(nZoomCount);
     nZoomCount = 0;
-    for (size_t idx = 0; idx < nbIndex; ++idx)
-    {
-      size_t globalIndex = index(idx);
-      globalIndexAxis(idx) = globalIndex;
-      if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end)
-      {
-        globalAxisZoom[nZoomCount] = globalIndex;
+    for (size_t idx = 0; idx < zoom_size; ++idx)
+    {
+      size_t globalZoomIndex = zoomByIndex() ? global_zoom_index(idx) : global_zoom_begin + idx;
+      if (globalZoomIndex >= minInd && globalZoomIndex <= maxInd)
+      {
+        globalAxisZoom[nZoomCount] = globalZoomIndex;
         ++nZoomCount;
       }
@@ -598,8 +618,16 @@
     int zoom_end = global_zoom_begin + global_zoom_n - 1;
     int nb = 0;
-    for (size_t idx = 0; idx < n; ++idx)
+/*    for (size_t idx = 0; idx < n; ++idx)
     {
       size_t globalIndex = begin + idx;
       if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end) ++nb;
+    }*/
+
+    int end = (0 == n) ? begin : begin + n - 1;
+    int zoom_size = zoomByIndex() ? global_zoom_index.numElements() : global_zoom_n;
+    for (size_t idx = 0; idx < zoom_size; ++idx)
+    {
+      size_t globalZoomIndex = zoomByIndex() ? global_zoom_index(idx) : global_zoom_begin + idx;
+      if (globalZoomIndex >= begin && globalZoomIndex <= end) ++nb;
     }
 
@@ -622,5 +650,5 @@
     CArray<double,1> val(nb);
     nb = 0;
-    for (size_t idx = 0; idx < n; ++idx)
+/*    for (size_t idx = 0; idx < n; ++idx)
     {
       size_t globalIndex = begin + idx;
@@ -628,4 +656,14 @@
       {
         val(nb) = value(idx);
+        ++nb;
+      }
+    }*/
+
+    for (size_t idx = 0; idx < zoom_size; ++idx)
+    {
+      size_t globalZoomIndex = zoomByIndex() ? global_zoom_index(idx) : global_zoom_begin + idx;
+      if (globalZoomIndex >= begin && globalZoomIndex <= end)
+      {
+        val(nb) = value(globalZoomIndex-begin);
         ++nb;
       }
@@ -933,4 +971,5 @@
         const int ni    = serverDimensionSizes[*itRank][orderPositionInGrid];
         const int end   = begin + ni - 1;
+        const bool zoomIndex = zoomByIndex();
 
         msgs.push_back(CMessage());
@@ -940,4 +979,7 @@
         msg << global_zoom_begin.getValue() << global_zoom_n.getValue();
         msg << isCompressible_;
+        msg << zoomIndex;
+        if (zoomIndex)
+          msg << global_zoom_index.getValue();
 
         event.push(*itRank,1,msg);
@@ -959,15 +1001,43 @@
   {
     int ni_srv, begin_srv, end_srv, global_zoom_begin_tmp, global_zoom_n_tmp;
+    bool zoomIndex;    
+    CArray<int,1> zoom_index_recv;
+    std::vector<int> zoom_index_tmp;
+    std::vector<int>::iterator itZoomBeginSrv, itZoomEndSrv, itZoomSrv;
 
     buffer >> ni_srv >> begin_srv >> end_srv;
     buffer >> global_zoom_begin_tmp >> global_zoom_n_tmp;
     buffer >> isCompressible_;
+    buffer >> zoomIndex;
+    if (zoomIndex)
+    {
+      buffer >> zoom_index_recv;
+      global_zoom_index.reference(zoom_index_recv);
+      zoom_index_tmp.resize(global_zoom_index.numElements());
+      std::copy(global_zoom_index.begin(), global_zoom_index.end(), zoom_index_tmp.begin());
+      std::sort(zoom_index_tmp.begin(), zoom_index_tmp.end());
+      itZoomBeginSrv = std::lower_bound(zoom_index_tmp.begin(), zoom_index_tmp.end(), begin_srv);
+      itZoomEndSrv   = std::upper_bound(zoom_index_tmp.begin(), zoom_index_tmp.end(), end_srv);      
+      int sz = std::distance(itZoomBeginSrv, itZoomEndSrv);
+      zoom_index_srv.resize(sz);
+      itZoomSrv = itZoomBeginSrv;
+      for (int i = 0; i < sz; ++i, ++itZoomSrv)
+      {
+        zoom_index_srv(i) = *(itZoomSrv);
+      }
+    }
+
     global_zoom_begin = global_zoom_begin_tmp;
     global_zoom_n  = global_zoom_n_tmp;
     int global_zoom_end = global_zoom_begin + global_zoom_n - 1;
 
-    zoom_begin_srv = global_zoom_begin > begin_srv ? global_zoom_begin : begin_srv ;
-    zoom_end_srv   = global_zoom_end < end_srv ? global_zoom_end : end_srv ;
+    zoom_begin_srv = zoomIndex ? std::distance(itZoomBeginSrv, zoom_index_tmp.begin())
+                                 : global_zoom_begin > begin_srv ? global_zoom_begin : begin_srv ;
+    zoom_end_srv   = zoomIndex ? std::distance(zoom_index_tmp.begin(), itZoomEndSrv) - 1 
+                                 : global_zoom_end < end_srv ? global_zoom_end : end_srv ;
     zoom_size_srv  = zoom_end_srv - zoom_begin_srv + 1;
+     
+    global_zoom_begin_srv = zoomIndex ? 0 : global_zoom_begin ;
+    global_zoom_size_srv  = zoomIndex ? zoom_index_tmp.size() : global_zoom_n;
 
     if (zoom_size_srv<=0)
@@ -978,7 +1048,8 @@
     if (n_glo == n)
     {
-      zoom_begin_srv = global_zoom_begin;
-      zoom_end_srv   = global_zoom_end; //zoom_end;
-      zoom_size_srv  = zoom_end_srv - zoom_begin_srv + 1;
+      zoom_begin_srv = zoomIndex ? std::distance(itZoomBeginSrv, zoom_index_tmp.begin())
+                                   : global_zoom_begin;      
+      zoom_size_srv  = zoomIndex ? zoom_index_tmp.size()
+                                   : global_zoom_n;
     }
     if (hasValue)
@@ -1043,6 +1114,4 @@
   }
 
-
-
   void CAxis::duplicateTransformation(CAxis* src)
   {
Index: /XIOS/dev/branch_yushan_merged/src/node/axis.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/node/axis.hpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/node/axis.hpp	(revision 1205)
@@ -122,7 +122,9 @@
         int zoom_begin_srv, zoom_end_srv, zoom_size_srv;
         int ni_srv, begin_srv, end_srv;
+        int global_zoom_begin_srv, global_zoom_end_srv, global_zoom_size_srv;
         CArray<double,1> value_srv;
         CArray<double,2> bound_srv;
         CArray<StdString,1> label_srv;
+        CArray<int,1> zoom_index_srv;
         bool hasValue;
 
@@ -138,4 +140,5 @@
          void sendDistributedValue();
          void sendNonDistributedValue();
+         bool zoomByIndex();
 
          static void recvIndex(CEventServer& event);
